; MIT License

; Copyright (c) 2020 María Belén Mera Reyes, Pablo Ramón Guevara

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.

.include "cpctelera.h.s"
.include "main.h.s"
.include "man/man_game.h.s"
.include "man/man_menu.h.s"
.include "man/man_level.h.s"

.area _DATA
.area _CODE


;; 0, 1, 2, 3, 4, 5, 6
;; x, y, ancho, alto, vx, vy, color

_limpiar_pantalla_carga: .db 0
_main::

   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm

   ld c, #0
   call cpct_setVideoMode_asm

   ld hl, #_sp_personaje_pal
   ld de, #16
   call cpct_setPalette_asm

   ;;MENU
   ld a, (_limpiar_pantalla_carga)
   cp #0
   jp nz, _no_limpiar

      ld a, #0
      call _man_menu_restore_background
      
   _no_limpiar:
      ld a, #1
      ld (_limpiar_pantalla_carga), a
      call _man_menu_init
      call _man_menu_run



  

   ld c, #0
   call cpct_setVideoMode_asm

   ld hl, #_sp_personaje_pal
   ld de, #16
   call cpct_setPalette_asm
   
   call _man_game_init


   

   ;; Loop forever
loop:
   call _man_game_update
   

   jr    loop
