; MIT License

; Copyright (c) 2020 María Belén Mera Reyes, Pablo Ramón Guevara

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.

.module game_manager

.include "man_game.h.s"
.include "man_entity.h.s"
.include "man_menu.h.s"
.include "sys/sys_physics.h.s"
.include "sys/sys_render.h.s"
.include "man_world.h.s"
.include "sys/sys_collision.h.s"
.include "sys/sys_input.h.s"
.include "man_level.h.s"



_man_game_init::

	ld a, #0x03
	call _man_menu_restore_background
	call _man_entity_init
	call _physics_init
	call _sys_input_init
	call _man_level_init

	ret

_man_game_update::

	call _sys_input_update
	call _sys_physics_update
	call _sys_collision_update
	call _man_level_update
	call _man_world_update
	call _man_game_render
	call _man_world_update
	ret

_man_game_render::
	call _sys_render_update

	ret

