; MIT License

; Copyright (c) 2020 María Belén Mera Reyes, Pablo Ramón Guevara

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.

;; Manager de Obstáculos/niveles

.include "man_level.h.s"
.include "man_entity.h.s"
.include "cpctelera.h.s"
.include "man_world.h.s"
.include "man_menu.h.s"
.include "main.h.s"

;;level1
level_entities:
;;PARA MUROS
	_obstaculo1: DefineEntity 69, 6, 11, 30, 0, 0, 1, _sp_obstaculo3
	_obstaculo2: DefineEntity 69, 50, 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo3: DefineEntity 69, 12 , 11, 30, 0, 0, 1, _sp_obstaculo3
;;PARA HUECO
	_obstaculo4: DefineEntity 69, 0 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo5: DefineEntity 69, 18 , 11, 30, 0, 0, 1, _sp_obstaculo3
	_obstaculo6: DefineEntity 69, 25 , 11, 30, 0, 0, 1, _sp_obstaculo3
	_obstaculo7: DefineEntity 69, 0 , 11, 30, 0, 0, 1, _sp_obstaculo3
;;EXTRA
	_obstaculo8: DefineEntity 69, 40 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo9: DefineEntity 69, 15 , 11, 30, 0, 0, 1, _sp_obstaculo3
;;PARA PIRAMIDE
	_obstaculo10: DefineEntity 69, 24 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo11: DefineEntity 69, 41 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo12: DefineEntity 69, 56 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo13: DefineEntity 69, 73 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo14: DefineEntity 69, 92 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo15: DefineEntity 69, 6 , 11, 16, 0, 0, 1, _sp_obstaculo2


;;level1
level2_entities:
	_obstaculo1_2: DefineEntity 65, 0, 15, 29, 0, 0, 1, _sp_obstaculo4
	_obstaculo2_2: DefineEntity 69, 60, 11, 16, -2, 0, 1, _sp_obstaculo2
	_obstaculo3_2: DefineEntity 69, 20 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo4_2: DefineEntity 69, 0 , 11, 16, -2, 0, 1, _sp_obstaculo2
	_obstaculo5_2: DefineEntity 65, 45 , 15, 29, 0, 0, 1, _sp_obstaculo4

	_obstaculo6_2: DefineEntity 69, 50 , 11, 30, -2, 0, 1, _sp_obstaculo3

	_obstaculo7_2: DefineEntity 69, 16 , 11, 16, 0, 0, 1, _sp_obstaculo2
	_obstaculo8_2: DefineEntity 69, 49 , 11, 16, 0, 0, 1, _sp_obstaculo2


_current_level:: .db 1
_finished_level:: .db 0 ; set to 1 when all obstacles have spawned

;; lvl 1
; 1 byte for dt, ptr to entity_data

_obstacles_lvl_1::

.db 0x0C
.dw #_obstaculo4

.db 0x2E
.dw #_obstaculo7

.db 0x2E
.dw #_obstaculo1

.db 0x06
.dw #_obstaculo2

;; fin
.db -1

_obstacles_lvl_2::

.db 0x0C
.dw #_obstaculo1_2

.db 0x1B
.dw #_obstaculo5_2

.db 0x1B
.dw #_obstaculo1_2

.db 0x08
.dw #_obstaculo5_2

.db 0x1B
.dw #_obstaculo1_2

.db 0x07
.dw #_obstaculo5_2

.db 0x1B
.dw #_obstaculo1_2

.db 0x1B
.dw #_obstaculo5_2

.db 0x1B
.dw #_obstaculo1_2

.db 0x08
.dw #_obstaculo5_2

;; fin
.db -1

_obstacles_lvl_3::

.db 0x0C
.dw #_obstaculo4

.db 0x1A
.dw #_obstaculo7

;;dos muros

	.db 0x2A
	.dw #_obstaculo1

	.db 0x0C
	.dw #_obstaculo6


;; comienzo pirámide

	.db 0x10
	.dw #_obstaculo7

	.db 0x0B
	.dw #_obstaculo10

	.db 0x09
	.dw #_obstaculo11

	.db 0x09
	.dw #_obstaculo12

	.db 0x09
	.dw #_obstaculo13

;; fin
.db -1

_obstacles_lvl_4::

.db 0x2E
.dw #_obstaculo1

.db 0x06
.dw #_obstaculo2

;;dos muros

	.db 0x1E
	.dw #_obstaculo7

	.db 0x0D
	.dw #_obstaculo6

;;hueco

	.db 0x1E
	.dw #_obstaculo4

	.db 0x0A
	.dw #_obstaculo5

	.db 0x1B
	.dw #_obstaculo5

	.db 0x0C
	.dw #_obstaculo7


.db 0x1B
.dw #_obstaculo2

.db 0x10
.dw #_obstaculo7

;; fin
.db -1

_obstacles_lvl_5::

;;hueco

	.db 0x0D
	.dw #_obstaculo4

	.db 0x0A
	.dw #_obstaculo5

	.db 0x1B
	.dw #_obstaculo5

	.db 0x0C
	.dw #_obstaculo7

;; muros con velocidades
	.db 0x10
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo3

	.db 0x11
	.dw #_obstaculo6_2



.db 0x1B
.dw #_obstaculo2

.db 0x10
.dw #_obstaculo7

.db 0x1C
.dw #_obstaculo1

.db 0x06
.dw #_obstaculo2

;; muros con velocidades
	.db 0x10
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo3

	.db 0x11
	.dw #_obstaculo6_2

;;descenso PIRAMIDE

	.db 0x14
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo13

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo10

	.db 0x1A
	.dw #_obstaculo1

;; fin
.db -1


_obstacles_lvl_6::

;;muros con velocidades

	.db 0x15
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo3

	.db 0x11
	.dw #_obstaculo6_2

;; comienzo pirámide

	.db 0x10
	.dw #_obstaculo7

	.db 0x0B
	.dw #_obstaculo10

	.db 0x09
	.dw #_obstaculo11

	.db 0x09
	.dw #_obstaculo12

	.db 0x09
	.dw #_obstaculo13

;; 2muros
	.db 0x0C
	.dw #_obstaculo1

	.db 0x0F
	.dw #_obstaculo2

	.db 0x10
	.dw #_obstaculo3

;;hueco

	.db 0x10
	.dw #_obstaculo4

	.db 0x0A
	.dw #_obstaculo5

	.db 0x15
	.dw #_obstaculo6

	.db 0x0C
	.dw #_obstaculo7

;;descenso PIRAMIDE

	.db 0x14
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo13

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo10

	.db 0x1A
	.dw #_obstaculo1

;;muros con velocidades

	.db 0x15
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo3

	.db 0x11
	.dw #_obstaculo6_2


;;pirámide

	.db 0x0C
	.dw #_obstaculo10

	.db 0x09
	.dw #_obstaculo11

	.db 0x09
	.dw #_obstaculo12

	.db 0x09
	.dw #_obstaculo13

	.db 0x14
	.dw #_obstaculo13

	.db 0x09
	.dw #_obstaculo12

	.db 0x09
	.dw #_obstaculo11

	.db 0x09
	.dw #_obstaculo10

;; aleatorio
	.db 0x0D
	.dw #_obstaculo7

	.db 0x12
	.dw #_obstaculo8

	.db 0x14
	.dw #_obstaculo9

	.db 0x0C
	.dw #_obstaculo10

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo13

	.db 0x12
	.dw #_obstaculo13

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo10

	.db 0x0A
	.dw #_obstaculo15


	;; fin
	.db -1

_obstacles_lvl_7::

;;descenso PIRAMIDE

	.db 0x10
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo13

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo10

	.db 0x1A
	.dw #_obstaculo1

;;hueco

	.db 0x10
	.dw #_obstaculo4

	.db 0x0A
	.dw #_obstaculo5

	.db 0x1E
	.dw #_obstaculo6

	.db 0x0C
	.dw #_obstaculo7

;; 2muros
	.db 0x10
	.dw #_obstaculo1

	.db 0x0F
	.dw #_obstaculo2

	.db 0x10
	.dw #_obstaculo3


;;muros con velocidades

	.db 0x15
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo3

	.db 0x11
	.dw #_obstaculo6_2

;; obstáculo con velocidad por abajo
	
	.db 0x11
	.dw #_obstaculo5

	.db 0x10
	.dw #_obstaculo5

	.db 0x2F
	.dw #_obstaculo4_2

;; aleatorio
	.db 0x0D
	.dw #_obstaculo7

	.db 0x12
	.dw #_obstaculo8

	.db 0x14
	.dw #_obstaculo9

	.db 0x0C
	.dw #_obstaculo10

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo13

	.db 0x12
	.dw #_obstaculo13

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo10

	.db 0x0A
	.dw #_obstaculo15

;;muros con velocidades

	.db 0x15
	.dw #_obstaculo1

	.db 0x15
	.dw #_obstaculo3

	.db 0x11
	.dw #_obstaculo6_2

;;pirámide

	.db 0x0C
	.dw #_obstaculo10

	.db 0x09
	.dw #_obstaculo11

	.db 0x09
	.dw #_obstaculo12

	.db 0x09
	.dw #_obstaculo13

	.db 0x15
	.dw #_obstaculo13

	.db 0x09
	.dw #_obstaculo12

	.db 0x09
	.dw #_obstaculo11

	.db 0x09
	.dw #_obstaculo10


;; aleatorio
	.db 0x0D
	.dw #_obstaculo7

	.db 0x12
	.dw #_obstaculo8

	.db 0x14
	.dw #_obstaculo9

	.db 0x0C
	.dw #_obstaculo10

	.db 0x0A
	.dw #_obstaculo11

	.db 0x0A
	.dw #_obstaculo12

	.db 0x0A
	.dw #_obstaculo13

	.db 0x12
	.dw #_obstaculo13


;;hueco

	.db 0x10
	.dw #_obstaculo4

	.db 0x0A
	.dw #_obstaculo5

	.db 0x15
	.dw #_obstaculo6

	.db 0x0C
	.dw #_obstaculo7

;; obstáculo con velocidad por abajo
	
	.db 0x11
	.dw #_obstaculo5

	.db 0x10
	.dw #_obstaculo5

	.db 0x2F
	.dw #_obstaculo4_2

;; aleatorio velocidades

	.db 0x0F
	.dw #_obstaculo2_2

	.db 0x0F
	.dw #_obstaculo3_2

	.db 0x00
	.dw #_obstaculo4_2

	.db 0x0F
	.dw #_obstaculo2_2

	.db 0x0F
	.dw #_obstaculo3_2

	;.db 0xFF
	;.dw #_obstaculoF

	;; fin
	.db -1

_obstacles_lvl_8::


.db -1


_frame_counter:: .db 0
_current_obstacle_ptr:: .dw #_obstacles_lvl_1

; Destruye bc
; ENTRADAS
; hl: *ptr
; SALIDA
; hl: ptr
_deref_hl::
	ld c, (hl)
	inc hl
	ld b, (hl)
	ld h, b
	ld l, c
	ret

_obstacle_spawner_update::
	; exit when finish
	ld hl, (_current_obstacle_ptr)
	;call _deref_hl
	ld a, (hl)
	ld b, #-1

	cp b
	jp nz, not_finished
	ld hl, #_finished_level
	ld (hl), #1

	ret
	not_finished:

	ld a, (_frame_counter) ; t

	ld hl, (_current_obstacle_ptr) ; hl: *_current_obstacle_ptr
	ld b, (hl) ; dt
	cp b ; b = obstacle_dt
	
	jp z, _spawn_obstacle

	; increment frame counter
	ld hl, #_frame_counter
	inc (hl)
	
	ret



; ENTRADAS
; hl: *obstacle ptr
_spawn_obstacle::

	push hl

	inc hl ; (hl): entity_data

	call _deref_hl

	; spawn
	call _man_entity_create_obstacle

	pop hl

	; increment current obstacle pointer
	ld bc, #3
	add hl, bc
	ld (_current_obstacle_ptr), hl

	; reset frame counter
	ld hl, #_frame_counter
	ld (hl), #0

	; calls obstacle_spawner_update again because dt can be 0
	; and multiple obstacles may be created at the same frame
	jp _obstacle_spawner_update

_man_level_update::
	jp _obstacle_spawner_update


_man_level_init::
	; set finished level
	ld hl, #_finished_level
	ld (hl), #0

	; set _frame_counter
	ld hl, #_frame_counter
	ld (hl), #0
	
	; set _current_obstacle_ptr
	ld a, (_current_level)
	cp a, #1
	jp z, init_lvl1
	cp a, #2
	jp z, init_lvl2
	cp a, #3
	jp z, init_lvl3
	cp a, #4
	jp z, init_lvl4
	cp a, #5
	jp z, init_lvl5
	cp a, #6
	jp z, init_lvl6
	cp a, #7
	jp z, init_lvl7
	cp a, #8
	jp z, init_lvl8
	ret

	init_lvl1:
		ld bc, #_obstacles_lvl_1
		jp load
	init_lvl2:
		ld bc, #_obstacles_lvl_2
		jp load
	init_lvl3:
		ld bc, #_obstacles_lvl_3
		jp load
	init_lvl4:
		ld bc, #_obstacles_lvl_4
		jp load
	init_lvl5:
		ld bc, #_obstacles_lvl_5
		jp load
	init_lvl6:
		ld bc, #_obstacles_lvl_6
		jp load
	init_lvl7:
		ld bc, #_obstacles_lvl_7
		jp load
	init_lvl8:
		ld hl, #_current_level
		ld (hl), #1
		ld bc, #_obstacles_lvl_1
		jp load
		ret
	load:
		ld hl, #_current_obstacle_ptr
		ld (hl), c
		inc hl
		ld (hl), b
		ret