; MIT License

; Copyright (c) 2020 María Belén Mera Reyes, Pablo Ramón Guevara

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.

;; MANAGER DE MENÚ
.include "man_menu.h.s"
.include "sys/sys_physics.h.s"
str_menu: .asciz "GAME MENU"
str_press: .asciz "Press N to"
str_start: .asciz "START"
str_win: .asciz "YOU WIN!!"
str_win_level: .asciz "LEVEL COMPLETED!!"
str_lose: .asciz "GAME OVER"
str_congrat: .asciz "CONGRATULATIONS"
str_you: .asciz "YOU HAVE"
str_completed: .asciz "COMPLETED"
str_all: .asciz "ALL THE LEVELS"
str_P: .asciz "P right"
str_O: .asciz "O left"
str_SPACE: .asciz "SPACE jump"

_man_menu_init::

	;;call sys_render_init ;; para poner el modod de video

	;ld hl, #0x0002  ;; color
	;call cpct_setDrawCharM0_asm
	;ld iy, #str_menu
	;X = 20
	;Y = 40
	;ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	;call cpct_drawStringM0_asm


	;;Press String 
	ld hl, #0x0004
	call cpct_setDrawCharM0_asm
	ld iy, #str_press
	X =20
	Y = 80
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #0x0004
	call cpct_setDrawCharM0_asm
	ld iy, #str_start
	X = 30
	Y = 120
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #FW_PURPLE
	call cpct_setDrawCharM0_asm
	ld iy, #str_O
	X =25
	Y = 160
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #FW_PURPLE
	call cpct_setDrawCharM0_asm
	ld iy, #str_P
	X = 40
	Y = 175
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #FW_PURPLE
	call cpct_setDrawCharM0_asm
	ld iy, #str_SPACE
	X =67
	Y = 190
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm



	ret

_man_menu_run::

	;;Key control
	call cpct_scanKeyboard_f_asm
	ld hl, #Key_N
	call cpct_isKeyPressed_asm  ;; hasta que no se pulse la tecla, no sale del bucle
	jr z, _man_menu_run

	ret


_man_menu_win_screen::

	ld hl, #0x0004
	call cpct_setDrawCharM0_asm
	ld iy, #str_win
	X = 20
	Y = 40
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ret

_man_menu_level_screen::

	ld hl, #FW_GREEN
	call cpct_setDrawCharM0_asm
	ld iy, #str_win_level
	X = 10
	Y = 40
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ret

_man_menu_lose_screen::

	ld hl, #FW_RED
	call cpct_setDrawCharM0_asm
	ld iy, #str_lose
	X = 20
	Y = 40
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ret

;;Entrada
;; a: color de fondo
_man_menu_restore_background::
	
	push af
	ld de, #0xC000
    ld c, #40 ;; width
    ld b, #200 ;; height
    
    call cpct_drawSolidBox_asm

    pop af
    ld de, #0xC000+#40
    ld c, #40 ;; width
    ld b, #200 ;; height
    call cpct_drawSolidBox_asm

	ret

_man_menu_finish_screen::
	
	;;Press String 
	ld hl, #0x0004
	call cpct_setDrawCharM0_asm
	ld iy, #str_congrat
	X =40
	Y = 20
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #FW_PURPLE
	call cpct_setDrawCharM0_asm
	ld iy, #str_you
	X = 55
	Y = 60
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #FW_PURPLE
	call cpct_setDrawCharM0_asm
	ld iy, #str_completed
	X = 50
	Y = 100
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm

	ld hl, #FW_PURPLE
	call cpct_setDrawCharM0_asm
	ld iy, #str_all
	X = 45
	Y = 140
	ld hl, #0xC000 + 64 * (Y / 8) + 2048 * (Y & 7) + X
	call cpct_drawStringM0_asm
	
	ret
