; MIT License

; Copyright (c) 2020 María Belén Mera Reyes, Pablo Ramón Guevara

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.

.include "man_world.h.s"
.include "man/man_menu.h.s"
.include "man/man_entity.h.s"
.include "man/man_level.h.s"
.include "main.h.s"


_man_world_update::
    jp _man_world_status_player


_man_world_status_player::
    ld iy, #_player
    
    ; if x <= 0, lost
    ld a, e_x(iy) 
    cp #10
    jp c, _lost

    ; can only win if _finished_level == 1
    ld a, (_finished_level)
    or a
    ret z

    call _man_entity_obstacles_empty
    ld a, #1 
    cp b
    jp z, _won

    ret

    ;; si estoy en player y no quedan obstáculos -> GANO
    ;; si estoy en player y me salgo de la pantalla (izquierda) -> PIERDO
    _won:

        
        ld hl, #_current_level
        inc (hl)
        ld b, #3
        cp b
        jr z, _pantalla_final

        ;;Llamo a las pantallas de inicio de juego
        ld a, #0
        call _man_menu_restore_background
        call _man_menu_level_screen
        call _man_level_init
        jp _main

        _pantalla_final:
            ld a, #0
            call _man_menu_restore_background
            call _man_menu_win_screen
            call _main

    _lost:
        ;;Llamo a las pantallas de inicio de juego
        ld a, #0
        call _man_menu_restore_background
        call _man_menu_lose_screen
        call _man_level_init
        jp _main