; MIT License

; Copyright (c) 2020 María Belén Mera Reyes, Pablo Ramón Guevara

; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in all
; copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE.

;;
;; RENDER SYSTEM
;;

.include "cpctelera.h.s"
.include "sys_render.h.s"
.include "man/man_entity.h.s"

;; ENTRADA
;; ix: dirección de memoria de player
;; SALIDA
;; hl: direccion de memoria de video
_get_screen_position::
    ; calcula y
    ld a, #200
    sub a, e_y(ix)
    sub a, e_h(ix)
    ld b, a

    ld c, e_x(ix) ;; x
    ld de, #0xC000
    jp cpct_getScreenPtr_asm
    

.globl cpct_waitVSYNC_asm

_sys_render_update::
    call cpct_waitVSYNC_asm
    ld hl, #_sys_render_entity
    call _man_entity_run_on_obstacles
    call _man_entity_run_on_player
    ret

;; ENTRADA
;; ix: direccion de entidad
_clear_previous_entity_position::
    ld d, e_lvmpv_h(ix)
    ld e, e_lvmpv_l(ix)
    ld b, e_h(ix)
    ld c, e_w(ix)
    ;xor a ; color de fondo

    ld a, #0x03
    jp cpct_drawSolidBox_asm

;; dibuja y guarda la direccion
;; ENTRADA
;; ix: direccion de entidad
_draw_and_store::
    call _get_screen_position ; dst
    
    ; store new dst
    ld e_lvmpv_h(ix), h
    ld e_lvmpv_l(ix), l

    ex de, hl

    ld h, e_ptr_sprite_h(ix)
    ld l, e_ptr_sprite_l(ix)
    ld b, e_h(ix)
    ld c, e_w(ix)
    jp cpct_drawSprite_asm

;; ENTRADA
;; ix: entidad
_sys_render_entity::
    call _clear_previous_entity_position
    jp _draw_and_store